org.apache.hc.core5.http2.impl.nio.bootstrap

## Class H2MultiplexingRequester

- java.lang.Object
- - org.apache.hc.core5.http.impl.bootstrap.AsyncRequester
  - - org.apache.hc.core5.http2.impl.nio.bootstrap.H2MultiplexingRequester

- All Implemented Interfaces:
    Closeable, AutoCloseable, ModalCloseable, ConnectionInitiator, IOReactor, IOReactorService

      public class H2MultiplexingRequester
      extends AsyncRequester

  HTTP/2 multiplexing client side message exchange initiator.
  Since:
    5.0

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `H2MultiplexingRequester(IOReactorConfig ioReactorConfig, IOEventHandlerFactory eventHandlerFactory, Decorator<IOSession> ioSessionDecorator, Callback<Exception> exceptionCallback, IOSessionListener sessionListener, Resolver<HttpHost,InetSocketAddress> addressResolver, TlsStrategy tlsStrategy)` Use `H2MultiplexingRequesterBootstrap` to create instances of this class.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `closeIdle(TimeValue idleTime)`
    `Future<IOSession>` | `connect(NamedEndpoint remoteEndpoint, SocketAddress remoteAddress, SocketAddress localAddress, Timeout timeout, Object attachment, FutureCallback<IOSession> callback)` Requests a connection to a remote host.
    `Cancellable` | `execute(AsyncClientExchangeHandler exchangeHandler, HandlerFactory<AsyncPushConsumer> pushHandlerFactory, Timeout timeout, HttpContext context)`
    `Cancellable` | `execute(AsyncClientExchangeHandler exchangeHandler, Timeout timeout, HttpContext context)`
    `<T> Future<T>` | `execute(AsyncRequestProducer requestProducer, AsyncResponseConsumer<T> responseConsumer, HandlerFactory<AsyncPushConsumer> pushHandlerFactory, Timeout timeout, HttpContext context, FutureCallback<T> callback)`
    `<T> Future<T>` | `execute(AsyncRequestProducer requestProducer, AsyncResponseConsumer<T> responseConsumer, Timeout timeout, FutureCallback<T> callback)`
    `<T> Future<T>` | `execute(AsyncRequestProducer requestProducer, AsyncResponseConsumer<T> responseConsumer, Timeout timeout, HttpContext context, FutureCallback<T> callback)`
    `Cancellable` | `execute(HttpHost target, AsyncClientExchangeHandler exchangeHandler, HandlerFactory<AsyncPushConsumer> pushHandlerFactory, Timeout timeout, HttpContext context)`
    `Cancellable` | `execute(HttpHost target, AsyncClientExchangeHandler exchangeHandler, Timeout timeout, HttpContext context)`
    `<T> Future<T>` | `execute(HttpHost target, AsyncRequestProducer requestProducer, AsyncResponseConsumer<T> responseConsumer, HandlerFactory<AsyncPushConsumer> pushHandlerFactory, Timeout timeout, HttpContext context, FutureCallback<T> callback)`
    `<T> Future<T>` | `execute(HttpHost target, AsyncRequestProducer requestProducer, AsyncResponseConsumer<T> responseConsumer, Timeout timeout, HttpContext context, FutureCallback<T> callback)`
    `H2ConnPool` | `getConnPool()`
    `Set<HttpHost>` | `getRoutes()`
    `TimeValue` | `getValidateAfterInactivity()`
    `void` | `setValidateAfterInactivity(TimeValue timeValue)`

    - ### Methods inherited from class org.apache.hc.core5.http.impl.bootstrap.AsyncRequester

      `awaitShutdown, close, close, defaultTarget, getStatus, initiateShutdown, requestSession, start`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### H2MultiplexingRequester

          @Internal
          public H2MultiplexingRequester(IOReactorConfig ioReactorConfig,
                                                   IOEventHandlerFactory eventHandlerFactory,
                                                   Decorator<IOSession> ioSessionDecorator,
                                                   Callback<Exception> exceptionCallback,
                                                   IOSessionListener sessionListener,
                                                   Resolver<HttpHost,InetSocketAddress> addressResolver,
                                                   TlsStrategy tlsStrategy)

      Use `H2MultiplexingRequesterBootstrap` to create instances of this class.

  - ### Method Detail

    - #### closeIdle

          public void closeIdle(TimeValue idleTime)

    - #### getRoutes

          public Set<HttpHost> getRoutes()

    - #### getValidateAfterInactivity

          public TimeValue getValidateAfterInactivity()

    - #### setValidateAfterInactivity

          public void setValidateAfterInactivity(TimeValue timeValue)

    - #### execute

          public Cancellable execute(HttpHost target,
                                     AsyncClientExchangeHandler exchangeHandler,
                                     HandlerFactory<AsyncPushConsumer> pushHandlerFactory,
                                     Timeout timeout,
                                     HttpContext context)

      Since:
        5.3

    - #### execute

          public Cancellable execute(AsyncClientExchangeHandler exchangeHandler,
                                     HandlerFactory<AsyncPushConsumer> pushHandlerFactory,
                                     Timeout timeout,
                                     HttpContext context)

    - #### execute

          public Cancellable execute(HttpHost target,
                                     AsyncClientExchangeHandler exchangeHandler,
                                     Timeout timeout,
                                     HttpContext context)

      Since:
        5.3

    - #### execute

          public Cancellable execute(AsyncClientExchangeHandler exchangeHandler,
                                     Timeout timeout,
                                     HttpContext context)

    - #### execute

          public final <T> Future<T> execute(HttpHost target,
                                             AsyncRequestProducer requestProducer,
                                             AsyncResponseConsumer<T> responseConsumer,
                                             HandlerFactory<AsyncPushConsumer> pushHandlerFactory,
                                             Timeout timeout,
                                             HttpContext context,
                                             FutureCallback<T> callback)

      Type Parameters:
        `T` - The result type returned by the Future's `get` method.
      Since:
        5.3

    - #### execute

          public final <T> Future<T> execute(AsyncRequestProducer requestProducer,
                                             AsyncResponseConsumer<T> responseConsumer,
                                             HandlerFactory<AsyncPushConsumer> pushHandlerFactory,
                                             Timeout timeout,
                                             HttpContext context,
                                             FutureCallback<T> callback)

    - #### execute

          public final <T> Future<T> execute(HttpHost target,
                                             AsyncRequestProducer requestProducer,
                                             AsyncResponseConsumer<T> responseConsumer,
                                             Timeout timeout,
                                             HttpContext context,
                                             FutureCallback<T> callback)

      Type Parameters:
        `T` - The result type returned by the Future's `get` method.
      Since:
        5.3

    - #### execute

          public final <T> Future<T> execute(AsyncRequestProducer requestProducer,
                                             AsyncResponseConsumer<T> responseConsumer,
                                             Timeout timeout,
                                             HttpContext context,
                                             FutureCallback<T> callback)

    - #### execute

          public final <T> Future<T> execute(AsyncRequestProducer requestProducer,
                                             AsyncResponseConsumer<T> responseConsumer,
                                             Timeout timeout,
                                             FutureCallback<T> callback)

    - #### getConnPool

          @Internal
          public H2ConnPool getConnPool()

    - #### connect

          public final Future<IOSession> connect(NamedEndpoint remoteEndpoint,
                                                 SocketAddress remoteAddress,
                                                 SocketAddress localAddress,
                                                 Timeout timeout,
                                                 Object attachment,
                                                 FutureCallback<IOSession> callback)

      Description copied from interface: `ConnectionInitiator`
      Requests a connection to a remote host.

      Opening a connection to a remote host usually tends to be a time consuming process and may take a while to complete. One can monitor and control the process of session initialization by means of the `Future` interface.

      There are several parameters one can use to exert a greater control over the process of session initialization:

      A non-null local socket address parameter can be used to bind the socket to a specific local address.

      An attachment object can added to the new session's context upon initialization. This object can be used to pass an initial processing state to the protocol handler.

      It is often desirable to be able to react to the completion of a session request asynchronously without having to wait for it, blocking the current thread of execution. One can optionally provide an implementation `FutureCallback` instance to get notified of events related to session requests, such as request completion, cancellation, failure or timeout.

      Specified by:
        `connect` in interface `ConnectionInitiator`
      Parameters:
        `remoteEndpoint` - name of the remote host.
        `remoteAddress` - remote socket address.
        `localAddress` - local socket address. Can be `null`, in which can the default local address and a random port will be used.
        `timeout` - connect timeout.
        `attachment` - the attachment object. Can be `null`.
        `callback` - interface. Can be `null`.
      Returns:
        session request object.

Copyright © 2005–2021 The Apache Software Foundation. All rights reserved.